#!/bin/sh
new_path="/var/log/new";
grep_var="$1":
clean_dir () {
rm -rf $new_path/*;
}

chk_args () {
if [ -z "$grep_var" ]; then
echo "Log Cleaner by hip0";
echo "Bad Syntax: .. $0 user";
exit 0;
fi
}

chk_dir () {
if [ -d "$i" ] && [ ! -a "$i" ] && [ -z "`echo $i | grep .gz`" ]; then
echo "$i is dir";
cp -rfp $i $new_path/$i;
new_i="$i";
for i in `ls -1 $new_path/$new_i`; do
#echo "$new_path/$i/$z";
sub_dir_files="$new_path/$new_i/$i";
echo $sub_dir_files;
done
fi
}

chk_file () {
if [ -a "$i" ] && [ ! -d "$i" ] && [ -z "`echo $i | grep .gz`" ]; then
echo "$i is file";
cp -pf $i $new_path/$i;
cat /dev/null > $new_path/$i;
cat $i | grep -v $grep_var > $new_path/$i
fi
}

chk_gz_file () {
if [ -n "`echo $i | grep .gz`" ] && [ -a "$i" ] && \
[ ! -d "$i" ]; then
echo "$i is gzipped file";
cp -pf $i $new_path/$i;
#echo "Ungzipping $new_path/$i";
gzip -d -f -q $new_path/$i;
gz_name="$i";
#echo "Cutting .gz";
cut_gz=${gz_name/.gz/};
#echo "catting $cut_gz and grepping $grep_var from it";
cat $new_path/$cut_gz | grep -v $grep_var > $new_path/$cut_gz.new;
#echo "Creating new $i";
gzip -c -f -q $new_path/$cut_gz.new > $new_path/$i;
rm -f $new_path/$cut_gz.new; rm -f $new_path/$cut_gz;
fi
}

main () {
chk_args;
clean_dir;
for i in `ls -1`; do
chk_dir;
chk_file;
chk_gz_file;
done
rm -f $new_path/`basename $0`;
}
main;

